// pages/mountings/mountings.js
const app = getApp();
Page({
  /**
   * 页面的初始数据
   */
  data: {
    imgUrl: app.globalData.urlStatic,//图片路径
    activityRule:false,//是否显示活动规则
    dataList:[],//数据列表
    userInfoData:false,//是否已获取用户头像昵称
    isAddress:false,//是否有地址
    addressShow:false,
    dateList:[],//日期列表
    dateChoose:'',//当前日的活动列表
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    app.globalData.nowPage = 3;
    if (app.globalData.openid) {
      this.loadFun(); 
    } else {
      app.globalData.openidSuccessFuc = this.loadFun;
    }
  },
  loadFun: function () {
    this.detectionUserMsg();
    this.getAddress();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getActivityDate();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '我正在参与启辰星秒杀增配活动，一起来秒杀！',
      imageUrl: this.data.imgUrl+'/newImages9/13.png',
      path: "/pages/mountings/mountings"
    }
  },
  ruleShowControl(){//控制活动规则的显示与隐藏
    this.setData({
      activityRule:!this.data.activityRule
    })
  },
  detectionUserMsg(){//检测是否已获取用户头像昵称
    if(app.globalData.userInfoData && app.globalData.userInfoData.avatarUrl){
      this.setData({
        userInfoData:true
      })
    }else{
      app.globalData.userInfoSuccessFuc = this.detectionUserMsg;
    }
  },
  getAddress: function () {//获取地址
    app.wxRequest(app.globalData.urlRoot + "address/getAddressV2", {}, res => {
      if (res.code == 200) {
        if (res.data) {
          this.data.isAddress = true;
        }
      }
    }, this)
  },
  joinActivity(e){
    let index = e.target.dataset.index;
    let state = this.data.dataList[index].state;
    if(state==-1){//我要砍价
      if(this.data.isAddress){
        this.beginBargain(this.data.dataList[index]);
      }else{
        this.setData({
          addressShow: true
        })
      }
    }else if(state==0){//查看详情
      wx.navigateTo({
        url: '/pages/mountingsDetail/mountingsDetail?sku_id='+this.data.dataList[index]['sku_id']+"&activity_token="+this.data.dataList[index]['activity_token'],
      })
    }else if(state==1){//已经成功
      wx.reLaunch({
        url: '/pages/myCenter/myCenter'
      })
    }
  },
  beginBargain(data){//发起砍价活动
    app.wxRequest(app.globalData.urlRoot + "bargain/beginBargain", {activity_id:data.id}, res => {
      if (res.code == 200) {
        data.activity_token = res.data.activity_token;
        wx.navigateTo({
          url: '/pages/mountingsDetail/mountingsDetail?sku_id='+data.sku_id+'&activity_token='+res.data.activity_token,
        })
      }else{
        wx.showToast({
          title: res.msg,
          icon: "none"
        })
      }
    }, this,"POST");
  },
  getUserWxMsg:function(e){//通过微信获取用户信息
    if (e.detail.errMsg == "getUserInfo:ok") {
      app.globalData.userInfoData = {};
      app.globalData.userInfoData.avatarUrl = e.detail.userInfo.avatarUrl;
      app.globalData.userInfoData.nickName = e.detail.userInfo.nickName;
      this.setData({
        userInfoData: true
      })
      app.submitUserMsg(e.detail.userInfo.avatarUrl, e.detail.userInfo.nickName);
      if(this.data.isAddress){
        wx.navigateTo({
          url: '/pages/mountingsDetail/mountingsDetail',
        })
      }else{
        this.setData({
          addressShow: true
        })
      }
    }
  },
  addressControl: function () {//跳转到地址管理
    this.setData({
      addressShow: !this.data.addressShow
    })
    if(!this.data.isAddress){
      this.getAddress();
    }
  },
  getActivityDate:function(){//获取展示日期
    app.wxRequest(app.globalData.urlRoot + "bargain/getActivityDate", {}, res => {
      if (res.code == 200) {
        for(let i=0;i<res.data.length;i++){
          let date = res.data[i]['activity_date'].split('-');
          res.data[i]['activity_date_show'] = date[1]+'月'+date[2]+'日';
        }
        if(res.data[0]){
          this.setData({
            dateChoose:res.data[0]['activity_date']
          })
          this.getActivityList();
          this.setData({
            dateList:res.data
          })
        }
      }
    }, this);
  },
  getActivityList:function(){//获取某日的活动列表
    app.wxRequest(app.globalData.urlRoot + "bargain/getActivityList", {activity_date:this.data.dateChoose}, res => {
      if (res.code == 200) {
        for(let i=0;i<res.data.list.length;i++){
          res.data.list[i]['goods_origin_price2'] = res.data.list[i]['goods_origin_price']/100;//原价（单位:分改为元）
          res.data.list[i]['goods_final_price2'] = res.data.list[i]['goods_final_price']/100;//底价（单位:分改为元）
          res.data.list[i]['goods_surplus_num'] = res.data.list[i]['goods_total_num']-res.data.list[i]['goods_success_num'];//剩余数量
          res.data.list[i]['consumeNum'] = Math.ceil((1-res.data.list[i]['goods_surplus_num']/res.data.list[i]['goods_total_num'])*100);//已抢进度
        }
        this.setData({
          dataList:res.data.list
        })
      }
    }, this);
  },
  dateChange(e){//选中日期发生改变
    var index = e.currentTarget.dataset.index;
    if(this.data.dateChoose != this.data.dateList[index]['activity_date']){
      this.setData({
        dataList:[],
        dateChoose:this.data.dateList[index]['activity_date']
      })
    }
    this.getActivityList();
  }
})